import { AbstractInputSuggest, type App, type FuzzyMatch, type TextComponent, SearchComponent, SearchMatches } from "obsidian";
declare module "obsidian" {
    interface AbstractInputSuggest<T> {
        selectSuggestion(value: T, evt: MouseEvent | KeyboardEvent): void;
    }
}
export declare abstract class FuzzyInputSuggest<T> extends AbstractInputSuggest<FuzzyMatch<T>> {
    items: T[];
    constructor(app: App, input: TextComponent | SearchComponent, items: T[]);
    abstract getItemText(item: T): string;
    protected getSuggestions(query: string): {
        item: T;
        match: import("obsidian").SearchResult;
    }[];
    abstract renderNote(noteEL: HTMLElement, result: FuzzyMatch<T>): void;
    abstract renderTitle(titleEl: HTMLElement, result: FuzzyMatch<T>): void;
    renderSuggestion(result: FuzzyMatch<T>, el: HTMLElement): void;
    renderMatches(el: HTMLElement | DocumentFragment, text: string, matches: SearchMatches | null, offset?: number): void;
}
//# sourceMappingURL=suggester.d.ts.map